<%
'*******************************************************************
'* Program : Power Stats
'* Version : 0.1
'* Authors : Ricardo Lerch, Rodrigo Alhadeff
'* Date    : March-2004
'* Details : functions to open and close db connection using dsn less string 
'*           
'*******************************************************************
%>
<!--#include virtual="/power-stats/includes/adovbs.inc"--> 
<%

sub openDb()
 if varType(connTemp)=0 or varType(connTemp)=1 then   
 
   ' create the connection
   set connTemp	= server.createObject("adodb.connection")      
    
   connTemp.Open pDatabaseConnectionString
 
   if err.number <> 0 then
    if pTrapDbErrors=0 or (err.number<>9 and err.number<>5 and err.number<>13 and err.number<>94 and err.number<>424 and err.number<>3265) then
     response.redirect "power-stats-supportError.asp?error="&Server.Urlencode("Error while opening DB read:"&Err.Description& "<br><br><b>Common solutions</b><br><br>1. Check that you haven't change default database path and name <br>2. Check that your web server has Access 97 or 2000 ODBC installed <br>3. Check that you have read, modify and delete permissions over database folder and database file  <br>4. Open your database with Access program and select Repair Database option <br>5. Select other connection method like other connection string or DSN")
    end if     
   end if
  
 end if 
end sub

sub getFromDatabase(mySQL, rsTemp, scriptName) 
  
   call openDb()
 
   set rsTemp = server.createObject("adodb.recordset")

   ' set locktype
   rsTemp.lockType = adLockReadOnly

   ' set the cursor
   rsTemp.cursorType = adOpenForwardOnly
   rsTemp.CursorLocation = adUseClient
   
   rsTemp.open mySQL, connTemp
   
   if err.number <> 0 then
    if pTrapDbErrors=0 or (err.number<>9 and err.number<>5 and err.number<>13 and err.number<>94 and err.number<>424 and err.number<>458 and err.number<>3265 and err.number>-2147467000 and err.number>-2000000000) then
      response.redirect "power-stats-supportError.asp?error="&Server.Urlencode("Error in " &scriptName& ", error: "&Err.Description& " - Err.Number:"&Err.number&" - SQL:"&mySQL)        
    end if 
   end if
 
end sub

sub getFromDatabasePerPage(mySQL, rsTemp, scriptName)

 call openDb()
 
 set rsTemp 		= server.createObject("adodb.recordset")     
 
 rsTemp.cursorLocation 	= adUseClient
 rsTemp.cacheSize 	= numPerPage
 
 rsTemp.open mySQL, connTemp
 
 if err.number <> 0 then
  if pTrapDbErrors=0 or (err.number<>9 and err.number<>5 and err.number<>13 and err.number<>94 and err.number<>424 and err.number<>3265 and err.number>-2000000000) then
    response.redirect "power-stats-supportError.asp?error="&Server.Urlencode("Error in " &scriptName& ", error: "&Err.Description& " - Err.Number:"&Err.number&" - SQL:"&mySQL)        
  end if 
 end if
 
end sub

sub getFromDatabaseSeek(mySQL, rsTemp, scriptName)

 call openDb()
 
 set rsTemp 		= server.createObject("adodb.recordset")
 rsTemp.cursorType 	= adOpenStatic
 rsTemp.lockType 	= adLockOptimistic

 rsTemp.Open mySQL, connTemp
 
 if err.number <> 0 then
  if  pTrapDbErrors=0 or (err.number<>9 and err.number<>5 and err.number<>13 and err.number<>94 and err.number<>424 and err.number<>3265 and err.number>-2000000000) then
    response.redirect "power-stats-supportError.asp?error="&Server.Urlencode("Error in " &scriptName& ", error: "&Err.Description& " - Err.Number:"&Err.number&" - SQL:"&mySQL)        
  end if 
 end if
 
end sub

sub updateDatabase(mySQL, rsTemp, scriptName) 
  
 call openDb()    
 
 set rsTemp=connTemp.execute(mySQL)
 
 if err.number <> 0 then
  if pTrapDbErrors=0 or (err.number<>9 and err.number<>5 and err.number<>6 and err.number<>13 and err.number<>94 and err.number<>424 and err.number<>3265 and err.number>-2000000000) then
   response.redirect "power-stats-supportError.asp?error="&Server.Urlencode("Error in " &scriptName& ", error: "&Err.Description& " - Err.Number:"&Err.number&" - SQL:"&mySQL)        
  end if    
 end if
  
end sub


function closeDB()
  on error resume next
  
  rsTemp.close
  set rsTemp 		= nothing 
  connTemp.close
  set connTemp	 	= nothing
 
end function

%>